#!/bin/bash

if test -f "diff_coeff.dat"; then
   rm diff_coeff.dat
fi

touch diff_coeff.dat

for i in 800 900 1000 1100 1200 1300 1400 1500 1600 1700 1800 1900 2000; do
   diffusion_coefficient.py XDATCAR.$i >>  diff_coeff.dat
   awk <PCDAT.$i >pair.$i ' NR==8 {pcskal=$1} NR==9 {pcfein=$1} NR>=10036 {line=line+1; print (line-0.5)*pcfein/pcskal,$1} '
done

gnuplot -e "set terminal jpeg; set key left; set xlabel 'time (ps)'; set ylabel 'D (Ang^2/ps)'; set style data lines; plot 'diff_coeff.dat' " > diff_coeff.jpg
#gnuplot -e "set terminal jpeg; set key left; set xlabel 'time (ps)'; set ylabel 'D (Ang^2/ps)'; set style data lines; plot 'diff_coeff.2000', 'diff_coeff.1900', 'diff_coeff.1800','diff_coeff.1700','diff_coeff.1600','diff_coeff.1500','diff_coeff.1400','diff_coeff.1300','diff_coeff.1200','diff_coeff.1100','diff_coeff.1000','diff_coeff.900','diff_coeff.800' " > diff_coeff.jpg


gnuplot -e "set terminal jpeg; set key left; set xlabel 'r (Ang)'; set ylabel 'PCF'; set style data lines; plot 'pair.2000', 'pair.1600','pair.1200','pair.1000','pair.800' " > pair.jpg

#gnuplot -e "set terminal jpeg; set key left; set xlabel 'r (Ang)'; set ylabel 'PCF'; set style data lines; plot 'pair.2000', 'pair.1900', 'pair.1800','pair.1700','pair.1600','pair.1500','pair.1400','pair.1300','pair.1200','pair.1100','pair.1000','pair.900','pair.800' " > pair.jpg

